#pragma once

#include "Object.h"
#include "ScriptletContainerFactory.h"
#include "ScriptletUtil.h"

interface IValueConverter : public Object
{
public:
	virtual ~IValueConverter() {}

	virtual CComVariant Convert(CComVariant* src) = 0;
};

class String2Boolean : public IValueConverter
{
public:
	DECLARE_CONVERTER_CREATOR(String2Boolean);
	String2Boolean() {}
	~String2Boolean() {}

	//override
	CComVariant Convert(CComVariant* src);
};

class InverseBoolean : public IValueConverter
{
public:
	DECLARE_CONVERTER_CREATOR(InverseBoolean);
	InverseBoolean() {}
	~InverseBoolean() {}

	//override
	CComVariant Convert(CComVariant* src)
	{
		BOOL bValue = ScriptUtil::Varient2BOOL(src);

		return CComVariant(!bValue);
	}
};

class ZeroCount: public IValueConverter
{
public:
	DECLARE_CONVERTER_CREATOR(ZeroCount);
	ZeroCount() {}
	~ZeroCount() {}

	//override
	CComVariant Convert(CComVariant* src)
	{
		return CComVariant(src->intVal == 0 ? SCRIPTLET_TRUE_VALUE : SCRIPTLET_FALSE_VALUE);
	}
};
class NoZeroCount: public IValueConverter
{
public:
	DECLARE_CONVERTER_CREATOR(NoZeroCount);
	NoZeroCount() {}
	~NoZeroCount() {}

	//override
	CComVariant Convert(CComVariant* src)
	{
		return CComVariant(src->intVal != 0 ? SCRIPTLET_TRUE_VALUE : SCRIPTLET_FALSE_VALUE);
	}
};